Simple In/Out API v4 Documentation

Welcome to the Simple In/Out API! You can use our API to access Simple In/Out data. You can request both read and write access.

The Simple In/Out v4 API is a RESTful (mostly) API protected by OAuth 2.

Rate Limiting

APIv4 is protected by daily rate limits. Currently, your application can access APIv4 up to 10,000 times per 24 hour period. Every request to APIv4 will return with two headers: X-RateLimit-Limit and X-RateLimit-Remaining. X-RateLimit-Limit will indicate the total number of requests that can be made against APIv4 over a 24 hour period (always 10,000 for now). X-RateLimit-Remaining will indicate how many requests you have left.

When you’ve run out of requests, APIv4 will return a HTTP status of 429 indicating Too Many Requests.

Expansions

Some of our APIs allow you to include additional information. This saves on API calls, as you can retrieve related information in the primary call and avoid additional requests.

When an API supports including additional information, it does so via the expand query parameter. This is a comma-delimited list of resources to include. We support expansions via embedding directly into the payload.

The Meta object

Most API payloads include a meta object to provide additional details about the requested resource(s). This includes paging most often, and sometimes additional information about the user making the request. For some payloads there may be additional items in the meta.

Here’s an example of a meta object

{"meta": {
  "paging": {
    "page": 1,
    "page_size": 25,
    "page_count": 2,
    "count": 47,
    "previous_page": null,
    "next_page": 2,
    "first_href": "https://www.simpleinout.com/api/v4/beacons",
    "last_href": "https://www.simpleinout.com/api/v4/beacons?page=2",
    "previous_href": null,
    "next_href": "https://www.simpleinout.com/api/v4/beacons?page=2"
  },
  "last_updated_at": {
    "announcements": 1435258926,
    "beacons": 1435250484,
    "favorites": 1437151284,
    "fences": 1436546484,
    "groups": 1436287284,
    "networks": 1436287284,
    "settings": 1439916084
  },
  emergency: nil
}}

Pagination

Pagination occurs when requesting multiple objects. Information about this appears in the meta object.

Name Description
page the page number currently being returned
page_size the number of results per page
page_count the total number of pages available
count the total number of results
previous_page the number of the previous page
next_page the number of the next page
first_href the URL of the API call for the first page of results
last_href the URL of the API call for the last page of results
previous_href the URL of the API call for the page of results prior to the current page
next_href the URL of the API call for the page of results after the current page

Last Update At

The last_updated_at attribute in the meta object returns the epoch time indicating the last time certain resources have been updated. This applies to the authorized user’s company. By storing these dates, you can discover when resources have been updated without having to poll those resources on a regular basis.

If Modified Since and If None Match

Most of the GET requests to the API support the If-Modified-Since and If-None-Match headers. If these two headers are present, the GET request will only return a payload if the relevant data has been updated since the time specified in the If-Modified-Since header and the ETag in the If-None-Match header. If it has been updated since, the payload will be the same as usual. If the data has not been updated, the return will be empty with a HTTP status of 304 (Not Modified). The format of the time is in the HTTP specification, while the ETag should be the same as that returned when a request has been made previously.

When a GET API returns data, the Last-Modified header will be present providing the exact time it’s been modified. This date should be used for future If-Modified-Since requests. The ETag header will be present providing the hash value representing the returned payload. This hash should be used for future If-None-Match requests.

Range Searching

Some integer or date/time fields can be searched by using operators. This permits exact searches, as well as less than, greater than, or between. For these fields, you have an array of options.

  • For exact matches, simply include the value. Date/time fields use epoch time, so it’s almost impossible to get an exact match to the second. Examples are 18 or 1524168783.
  • For ranges based on a single value, you may prepend a symbol to the front of the value. The symbols <, >, <=, or >= are supported. Examples are <18 or >=1524168783.
  • For between range searches, the .. operator is used in between the two values. This includes the values on both ends, as well as those in between. Examples are 9..18 or 1523854800..1524459599.

Sorting

When requesting multiple objects, most of the time you’ll have some sorting options available. Sorting occurs by passing in the sort query parameter. The value is a comma-delimited string of fields in the order you wish them to be sorted. By default, all fields will sort in ascending fashion, but you can sort in descending fashion by including a - sign before the field. An example of this would be sort=name,-begin_at.

Errors

Error objects in Simple In/Out consist of three parts: code, message, and details.

  • code corresponds with those listed below. These provide context as to what type of error occurred.
  • message is an English plain-text reading of what happened. This should be used for further developer debugging, but should not be relied on to remain consistent over time. While these messages can be displayed to end-users, it is highly discouraged as they can change without notice and they are always going to be in English.
  • details provides an array of information in the case of validation failures. This will typically be populated with 5005 validation errors, though they also can appear with improperly formatted status updates (2002). The format of the objects in the array are key: value pairs, whereby key is the name of a field and value is one of a number of possible strings to indicated more specifically what was invalid with the input. Please note that while the key will typically be a parameter on the object, it can occasionally be base for errors that fail validation but don’t apply to a particular field.

An example of an error payload:

{
  "code": 5005,
  "message": "Validation Failure: Name can't be blank, UUID is invalid, Beacons exceed company limit of 100",
  "details": [
    { "name": "blank" },
    { "uuid": "invalid" },
    { "base": "greater_than" }
  ]
}

Error Codes

1002: Company is Disabled

Either the user’s company was on a trial and the trial has expired or the company has let their subscription to Simple In/Out expire. This error will present itself on almost all APIs and will return with the status code 403.


2002: Status Failure

The status update could not be completed.


5001: Bad Range

The integer or date value/range is invalid.


5002: Unknown Sort

The sort requested does not exist. The full message of this error will provide more explanation.


5003: Unknown Expansion

The expansion requested does not exist. The full message of this error will provide more explanation.


5005: Validation Failure

When attempting to create/update/delete the object, some data was either missing or invalid. The full message of this error will provide more explanation.


5007: Parameters Missing

A required parameter for this API was missing.


5008: Array Required

A parameter which is required to be an array was passed something other than an array.


5009: Unknown Only

The only field requested does not exist. The full message of this error will provide more explanation.


5010: Invalid Float

The floating point number is invalid.


5012: Invalid JSON

The posted JSON body is invalid.


5013: Invalid Page Size of Zero

The page_size parameter cannot be zero.


5014: Invalid mime-type requested

An invalid mime-type was requested.

Error Details

taken

The attribute is not unique

inclusion

The attribute is not in the list of acceptable values

invalid

The attribute is not valid

empty

The attribute cannot be empty

blank

The attribute cannot be blank

too_long

The attribute is too long

not_a_hex

The attribute is not a valid hex color code

not_a_number

The attribute is not a number

not_an_integer

The attribute is not an integer

greater_than

The attribute is greater than a predefined limit

greater_than_or_equal_to

The attribute is greater than or equal to a predefined limit

less_than

The attribute is less than a predefined floor

less_than_or_equal_to

The attribute is greater than or equal to a predefined floor

too_long

The attribute is longer than allowed

too_short

The attribute is shorter than allowed

Forbidden Requests (403)

When the user is authenticated, but doesn’t have the necessary permissions to perform an action, the server will respond with the status code of 403 and include the user’s privileges in the payload.

Example payload:

{
  "company": {
    "id": "1",
    "scheduled_statuses": true
  },
  "user": {
    "id": "5",
    "roles": {
      "name": "Regular User",
      "billing": false
      "followed_users": false,
      "reminders": false,
      "safeties": false,
      "user_board": true,
      "manage_all_announcements": true,
      "manage_company_and_users": false,
      "manage_groups_and_memberships": false,
      "manage_member_announcements": false,
      "manage_others_archives": false,
      "manage_others_futures": false,
      "manage_others_status": false,
      "manage_own_archives": false,
      "manage_own_futures": true,
      "manage_own_status": true,
      "manage_status_automatically": true,
      "view_others_archives": true,
      "view_others_futures": true,
      "view_others_reports": false,
      "view_user_board_updated_at": true,
      "member_board": false,
      "manage_member_archives": false,
      "manage_member_futures": false,
      "manage_member_status": false,
      "view_all_announcements": true,
      "view_member_announcements": false,
      "view_member_archives": false,
      "view_member_futures": false,
      "view_member_reports": false,
      "created_at": 1506268448,
      "updated_at": 1506269853
    }
  }
}

The privileges payload may not exist on all forbidden responses. In the cases when an error code is used, such as when a company is disabled, only the code and message will be returned.

Web Hooks

Web Hooks are a great way to be notified when something happens inside Simple In/Out. When you add a Web Hook URL to Simple In/Out, we’ll send a request to that URL with JSON in the body to tell you about things that have happened.

Currently, this applies to only three event types: status.new, status.schedule, and status.destroy, though many may be added in the future. It is strongly advised that you code against the type attribute on the root of the JSON object to avoid new event types being added in the future having unexpected impacts on your code.

The root JSON keys define the basics and out of the box are compatible with Slack’s incoming webhooks. This also means that the text with be formatted in Markdown. Within the data object is much of the information specific to Simple In/Out, including ids that can be used in combination with APIv4 to request further information.

{
  "username": "Bojack Horseman",
  "email": "bojack@simplymadeapps.com",
  "icon_url": "http://bojackhorseman.com/avatar.gif",
  "text": "*In*: In Hollywoo",
  "type": "status.new",
  "data": {
    "user_id": "34858",
    "status": "in",
    "comment": "In Hollywoo",
    "created_at": 1448046759,
    "admin": {
      "id": "2844", "name": "Princess Carolyn"
    },
    "application": {
      "id": "84774", "name": "Simple In/Out iOS"
    }
  }
}



Announcements

Create a announcement

Creates a new announcement. Once this announcement is created, it will appear in the company’s announcements within the Simple In/Out apps. Users must have a role that permits managing announcements to create announcements. Companies are limited to 100 announcements.

Endpoint

POST /api/v4/announcements

Parameters

Name Description
announcement[message] required (string) the name of the announcement
announcement[push] (boolean) whether this announcement should trigger a push notification to users, defaults to false
announcement[group_id] (string) restrict the announcement to a specific group, defaults to no restrictions
announcement[expires_at] (integer) the epoch time when the announcement should expire, defaults to no expiration
expand (string) comma-delimited list of extra information to include in the response, possibilities include: 'user'

Request

Route

POST /api/v4/announcements

Headers

Content-Type: application/json
Authorization: Bearer j9gZ9GgDsWMlB4msT3N48tI-oMpA9RI94g4xfnfjnsY

Body

{
  "announcement": {
    "message": "Evacuate the building",
    "push": false,
    "group_id": "122",
    "expires_at": 1792089011
  }
}

cURL

curl "https://www.simpleinout.com/api/v4/announcements" -d '{"announcement":{"message":"Evacuate the building","push":false,"group_id":"122","expires_at":1792089011}}' -X POST \
	-H "Content-Type: application/json" \
	-H "Authorization: Bearer j9gZ9GgDsWMlB4msT3N48tI-oMpA9RI94g4xfnfjnsY"

Response

Simulated Response

Response Fields

Name Description
announcements (object) the newly created announcement attributes

Status

201

Headers

etag: W/"60a7d2e6f80c8d9662b2ecad2241db0b"

Body

{
  "announcements": {
    "id": "46",
    "group_id": "122",
    "user_id": "1839",
    "message": "Evacuate the building",
    "push": false,
    "expires_at": 1792089011,
    "created_at": 1792002611,
    "updated_at": 1792002611
  },
  "meta": {
    "last_updated_at": {
      "announcements": 1792002611,
      "beacons": 1788460211,
      "desktop_presences": 1788805811,
      "favorites": 1788633011,
      "fences": 1789497011,
      "groups": 1792002611,
      "networks": 1791916211,
      "roles": 1792002611,
      "settings": 1792002611
    },
    "emergency": null
  }
}

Delete an announcement

Deletes an existing announcement. Users must have a role that permits managing the announcements to delete announcements.

Endpoint

DELETE /api/v4/announcements/:id

Request

Route

DELETE /api/v4/announcements/47

Headers

Content-Type: application/json
Authorization: Bearer 4G5IFUg-mwEhfKcbvEY-LrHlhhZzzldhdgS52wLlg44

cURL

curl "https://www.simpleinout.com/api/v4/announcements/47" -d '' -X DELETE \
	-H "Content-Type: application/json" \
	-H "Authorization: Bearer 4G5IFUg-mwEhfKcbvEY-LrHlhhZzzldhdgS52wLlg44"

Response

Simulated Response

Status

204

List all announcements

Return a list of all the announcements belonging to the company.

Endpoint

GET /api/v4/announcements

Parameters

Name Description
sort (string) order of the return with optional '-' to denote descending, possibilities include: 'name'
page_size (integer) number of results to return per page, defaults to 25
page (integer) page number of results
expand (string) comma-delimited list of extra information to include in the response, possibilities include: 'user'

Request

Route

GET /api/v4/announcements

Headers

Content-Type: application/json
Authorization: Bearer y19bU8R1Kw8BUSPN8CcPH9VoyElSQlR1duRxAz0rggA

cURL

curl -g "https://www.simpleinout.com/api/v4/announcements" -X GET \
	-H "Content-Type: application/json" \
	-H "Authorization: Bearer y19bU8R1Kw8BUSPN8CcPH9VoyElSQlR1duRxAz0rggA"

Response

Simulated Response

Response Fields

Name Description
announcements (array) an array of announcements

Status

200

Headers

etag: W/"e218e9055f04d558e55cdfde9b8f454d"

Body

{
  "announcements": [
    {
      "id": "44",
      "group_id": null,
      "user_id": "1838",
      "message": "Reiciendis est ab eius.",
      "push": false,
      "expires_at": 1792089011,
      "created_at": 1792002611,
      "updated_at": 1792002611
    },
    {
      "id": "45",
      "group_id": null,
      "user_id": "1838",
      "message": "Blanditiis sed tenetur laboriosam.",
      "push": false,
      "expires_at": 1792089011,
      "created_at": 1792002611,
      "updated_at": 1792002611
    }
  ],
  "meta": {
    "paging": {
      "page": 1,
      "page_size": 25,
      "page_count": 1,
      "count": 2,
      "previous_page": null,
      "next_page": null,
      "first_href": "http://example.org/api/v4/announcements",
      "last_href": "http://example.org/api/v4/announcements",
      "previous_href": null,
      "next_href": null
    },
    "last_updated_at": {
      "announcements": 1792002611,
      "beacons": 1788546611,
      "desktop_presences": 1785349811,
      "favorites": 1788978611,
      "fences": 1785090611,
      "groups": 1791829811,
      "networks": 1792002611,
      "roles": 1792002611,
      "settings": 1792002611
    },
    "emergency": null
  }
}

Authentication

Authorization

Authorization is required to access the Simple In/Out API. This results in a HTTP 302 redirect to simpleinout.com. There, Simple In/Out will ask the user for their credentials and verify they wish to grant your application permission to act on their behalf. If they allow it, Simple In/Out will send a request to your redirect_uri with a code that you can use in the Authorization Code grant to have access and refresh tokens to access the API.

Endpoint

GET /oauth/authorize

Parameters

Name Description
response_type required (string) the type of authorization to use, in this case always 'code'
client_id required (string) your API client key
redirect_uri required (string) the URI to return the user to after authenticating, must match those registered with Simple In/Out
scope required (string) requested scope, either 'read' or 'write', by default 'read'
locale (string) the language for authorization. Available locales: en, en-au, en-ca, en-gb, de, es, fr, fr-ca. Defaults to 'en'

Request

Route

GET /oauth/authorize?response_type=code&client_id=PLACE_YOUR_API_CLIENT_ID_HERE&redirect_uri=https%3A%2F%2Fwww.simplymadeapps.com%2Fredirect%2Furl&scope=write&locale=en

Headers

Content-Type: application/json

Query Parameters

response_type=code
client_id=PLACE_YOUR_API_CLIENT_ID_HERE
redirect_uri=https://www.simplymadeapps.com/redirect/url
scope=write
locale=en

cURL

curl -g "https://www.simpleinout.com/oauth/authorize?response_type=code&client_id=PLACE_YOUR_API_CLIENT_ID_HERE&redirect_uri=https%3A%2F%2Fwww.simplymadeapps.com%2Fredirect%2Furl&scope=write&locale=en" -X GET \
	-H "Content-Type: application/json"

Response

Simulated Response

Status

302

Authorization Code grant

Authorization Code should be used for accessing the API on behalf of a particular user. This is useful for pulling information about the user, or customizing the return of some APIs by the user’s preference.

The first step here is to have your user authorize your app for use. To do this, send your user to our site as noted to the left, passing your client_id and your redirect_uri. We’ll handle asking for the user, authenticating they are who they say they are, and handling the authorization (asking the user for permission on your behalf).

Once your user successfully authorizes your application, they will be redirected back to you. In this response will be a code in the form of a query string. Use this code to request tokens from Simple In/Out. You’ll then receive an access token and refresh token.

Endpoint

POST /oauth/token

Parameters

Name Description
grant_type required (string) type of grant to use
client_id required (string) your API client key
client_secret required (string) your API client secret
code required (string) if using Authorization Code grant, this is the code that is returned from Simple In/Out
redirect_uri required (string) the URI to return the user to after authenticating, must match those registered with Simple In/Out
scope (string) requested scope, either 'read' or 'write', defaults to 'read'

Request

Route

POST /oauth/token

Headers

Content-Type: application/json

Body

{
  "grant_type": "authorization_code",
  "client_id": "YOUR_API_CLIENT_ID",
  "client_secret": "YOUR_API_CLIENT_SECRET",
  "code": "hBm_hwU0pvCuq5BB77VYtgngpYQJkFqiizMwDQHwOJ4",
  "redirect_uri": "https://www.simplymadeapps.com/redirect/url"
}

cURL

curl "https://www.simpleinout.com/oauth/token" -d '{"grant_type":"authorization_code","client_id":"YOUR_API_CLIENT_ID","client_secret":"YOUR_API_CLIENT_SECRET","code":"hBm_hwU0pvCuq5BB77VYtgngpYQJkFqiizMwDQHwOJ4","redirect_uri":"https://www.simplymadeapps.com/redirect/url"}' -X POST \
	-H "Content-Type: application/json"

Response

Simulated Response

Response Fields

Name Description
access_token (string) the access token used to make API requests
refresh_token (string) used with the Refresh Token grant type to request a new token
token_type (string) identifies the type of token
expires_in (integer) length of time, in seconds, that the token will be honored
scope (string) the scope of the token, either 'read' or 'write'
created_at (integer) the time the token was issued
user (object) the authenticated user's id, company id, and role.

Status

200

Headers

etag: W/"2665e2823c8f2ade77fda881fcea1aae"

Body

{
  "access_token": "IQOOIw2CNYR2jZsOONBXkoRn-uNUX5nEtdW3pz5-gos",
  "token_type": "Bearer",
  "expires_in": 120,
  "refresh_token": "qxFAJEzXvthNnzbtILPNkTnw5a67nXs8A3lW-LIob-M",
  "scope": "write",
  "created_at": 1792002610,
  "user": {
    "id": "1802",
    "company_id": "1205",
    "roles": {
      "id": "5093",
      "name": "Administrator",
      "billing": true,
      "followed_users": true,
      "reminders": true,
      "safeties": true,
      "user_board": true,
      "manage_all_announcements": true,
      "manage_company_and_users": true,
      "manage_member_announcements": false,
      "manage_groups_and_memberships": true,
      "manage_others_archives": true,
      "manage_others_futures": true,
      "manage_others_status": true,
      "manage_own_archives": true,
      "manage_own_futures": true,
      "manage_own_status": true,
      "manage_status_automatically": true,
      "view_others_archives": true,
      "view_others_futures": true,
      "view_others_reports": true,
      "view_user_board_updated_at": true,
      "member_board": false,
      "manage_member_archives": false,
      "manage_member_futures": false,
      "manage_member_status": false,
      "view_all_announcements": true,
      "view_member_announcements": false,
      "view_member_archives": false,
      "view_member_futures": false,
      "view_member_reports": false,
      "created_at": 1792002610,
      "updated_at": 1792002610
    }
  }
}

Refresh Token grant

Refresh Token should be used to renew your access token in the event that it has expired. This is useful for regaining access without again having to as the user for credentials.

Endpoint

POST /oauth/token

Parameters

Name Description
grant_type required (string) type of grant to use, in this case always 'refresh_token'
client_id required (string) your API client key
client_secret required (string) your API client secret
refresh_token required (string) your refresh token

Request

Route

POST /oauth/token

Headers

Content-Type: application/json

Body

{
  "grant_type": "refresh_token",
  "client_id": "YOUR_API_CLIENT_ID",
  "client_secret": "YOUR_API_CLIENT_SECRET",
  "refresh_token": "aoyfu42zixw0jp6311f6u0a69msd3bwb"
}

cURL

curl "https://www.simpleinout.com/oauth/token" -d '{"grant_type":"refresh_token","client_id":"YOUR_API_CLIENT_ID","client_secret":"YOUR_API_CLIENT_SECRET","refresh_token":"aoyfu42zixw0jp6311f6u0a69msd3bwb"}' -X POST \
	-H "Content-Type: application/json"

Response

Simulated Response

Response Fields

Name Description
access_token (string) the access token used to make API requests
refresh_token (string) used with the Refresh Token grant type to request a new token
token_type (string) identifies the type of token
expires_in (integer) length of time, in seconds, that the token will be honored
scope (string) the scope of the token, either 'read' or 'write'
created_at (integer) the time the token was issued
user (object) the authenticated user's id and role.

Status

200

Headers

etag: W/"9434bbabe2323e19283ee981efa0f5f7"

Body

{
  "access_token": "74RARkHhl1peh5wDKohGgWISHICCHDy3Aef8Ka4wsBE",
  "token_type": "Bearer",
  "expires_in": 604800,
  "refresh_token": "Q5yTo700SpuuE88k7nklOgclIHRMKq-JsWlVeDAc89A",
  "scope": "write",
  "created_at": 1792002610,
  "user": {
    "id": "1806",
    "company_id": "1208",
    "roles": {
      "id": "5105",
      "name": "Administrator",
      "billing": true,
      "followed_users": true,
      "reminders": true,
      "safeties": true,
      "user_board": true,
      "manage_all_announcements": true,
      "manage_company_and_users": true,
      "manage_member_announcements": false,
      "manage_groups_and_memberships": true,
      "manage_others_archives": true,
      "manage_others_futures": true,
      "manage_others_status": true,
      "manage_own_archives": true,
      "manage_own_futures": true,
      "manage_own_status": true,
      "manage_status_automatically": true,
      "view_others_archives": true,
      "view_others_futures": true,
      "view_others_reports": true,
      "view_user_board_updated_at": true,
      "member_board": false,
      "manage_member_archives": false,
      "manage_member_futures": false,
      "manage_member_status": false,
      "view_all_announcements": true,
      "view_member_announcements": false,
      "view_member_archives": false,
      "view_member_futures": false,
      "view_member_reports": false,
      "created_at": 1792002610,
      "updated_at": 1792002610
    }
  }
}

Revoke a token

Revokes a token, rendering it invalid.

Endpoint

POST /oauth/revoke

Parameters

Name Description
client_id required (string) your API client key
client_secret required (string) your API client secret
token required (string) the token to revoke

Request

Route

POST /oauth/revoke

Headers

Content-Type: application/json

Body

{
  "client_id": "6157719867609",
  "client_secret": "2300051538421",
  "token": "vdMVIaGCKEezWLyPKXpw1ejeNEif3UmvHUseFA6TDMA"
}

cURL

curl "https://www.simpleinout.com/oauth/revoke" -d '{"client_id":"6157719867609","client_secret":"2300051538421","token":"vdMVIaGCKEezWLyPKXpw1ejeNEif3UmvHUseFA6TDMA"}' -X POST \
	-H "Content-Type: application/json"

Response

Simulated Response

Status

200

Headers

etag: W/"44136fa355b3678a1146ad16f7e8649e"

Body

{}

Token information

Provides details about the OAuth token.

Endpoint

GET /oauth/token/info

Request

Route

GET /oauth/token/info

Headers

Content-Type: application/json
Authorization: Bearer rrt3GD0Pbfe7PkBtcASwhNB6j0pCt1YgzKPTx4qmkXQ

cURL

curl -g "https://www.simpleinout.com/oauth/token/info" -X GET \
	-H "Content-Type: application/json" \
	-H "Authorization: Bearer rrt3GD0Pbfe7PkBtcASwhNB6j0pCt1YgzKPTx4qmkXQ"

Response

Simulated Response

Response Fields

Name Description
resource_owner_id (integer) the id of the user
scopes (array) the scopes this token is authorized to use
expires_in_seconds (integer) the number of seconds until the token expires
application (object) information about the application
created_at (integer) the time the token was issued

Status

200

Headers

etag: W/"1c18770dad245c8248cdce63bc5ac606"

Body

{
  "resource_owner_id": 1804,
  "scope": [
    "read"
  ],
  "expires_in": 604800,
  "application": {
    "uid": "1968265077597"
  },
  "created_at": 1792002610
}

Beacons

Create a beacon

Creates a new beacon. Once this beacon is created, it will appear in the company’s beacons within the Simple In/Out apps. The UUID can then be added to a hardware beacon to broadcast. Users must have a role that permits managing the company to create beacons. Companies are limited to 100 Beacons.

Endpoint

POST /api/v4/beacons

Parameters

Name Description
beacon[name] required (string) the name of the beacon
beacon[uuid] (string) the unique beacon identifier
beacon[comment_on_entry] (string) the comment applied to status updates on entry, defaults to 'In at {name}'
beacon[comment_on_exit] (string) the comment applied to status updates on exit, defaults to 'Left {name}'
beacon[status_on_entry] (string) the status to apply on entry: 'in', 'remote', 'busy', 'break', 'out', 'sick', 'vacation', or 'off', defaults to 'in'
beacon[status_on_exit] (string) the status to apply on exit: 'in', 'remote', 'busy', 'break', 'out', 'sick', 'vacation', or 'off', defaults to 'out'

Request

Route

POST /api/v4/beacons

Headers

Content-Type: application/json
Authorization: Bearer dFsSow8Fkdy-qeL1-0Ka22RZ9F2lA0lI3BSwkmYRrU4

Body

{
  "beacon": {
    "name": "My Office",
    "uuid": "6EA4801F-4D41-4114-AFA7-7EC977C81B41"
  }
}

cURL

curl "https://www.simpleinout.com/api/v4/beacons" -d '{"beacon":{"name":"My Office","uuid":"6EA4801F-4D41-4114-AFA7-7EC977C81B41"}}' -X POST \
	-H "Content-Type: application/json" \
	-H "Authorization: Bearer dFsSow8Fkdy-qeL1-0Ka22RZ9F2lA0lI3BSwkmYRrU4"

Response

Simulated Response

Response Fields

Name Description
beacons (object) the newly created beacon attributes

Status

201

Headers

etag: W/"b08039fedcb183edcc1dc6eba617e335"

Body

{
  "beacons": {
    "id": "25",
    "name": "My Office",
    "uuid": "6EA4801F-4D41-4114-AFA7-7EC977C81B41",
    "comment_on_entry": "In at My Office",
    "comment_on_exit": "Left My Office",
    "entry": true,
    "exit": true,
    "status_on_entry": "in",
    "status_on_exit": "out",
    "created_at": 1792002611,
    "updated_at": 1792002611
  },
  "meta": {
    "last_updated_at": {
      "announcements": 1789497011,
      "beacons": 1792002611,
      "desktop_presences": 1791225011,
      "favorites": 1790533811,
      "fences": 1786905011,
      "groups": 1789497011,
      "networks": 1791397811,
      "roles": 1792002611,
      "settings": 1792002611
    },
    "emergency": null
  }
}

Delete a beacon

Deletes an existing beacon. Users must have a role that permits managing the company to delete beacons.

Endpoint

DELETE /api/v4/beacons/:id

Request

Route

DELETE /api/v4/beacons/27

Headers

Content-Type: application/json
Authorization: Bearer TId309p6KHljM3hzRsvY1eGZrVMwBDq3QQOE9AGHpj0

cURL

curl "https://www.simpleinout.com/api/v4/beacons/27" -d '' -X DELETE \
	-H "Content-Type: application/json" \
	-H "Authorization: Bearer TId309p6KHljM3hzRsvY1eGZrVMwBDq3QQOE9AGHpj0"

Response

Simulated Response

Status

204

List all beacons

Return a list of all the beacons belonging to the company.

Endpoint

GET /api/v4/beacons

Parameters

Name Description
sort (string) order of the return with optional '-' to denote descending, possibilities include: 'name'
page_size (integer) number of results to return per page, defaults to 25
page (integer) page number of results

Request

Route

GET /api/v4/beacons

Headers

Content-Type: application/json
Authorization: Bearer 7mhcJIS-e5uvhiJwhAf0tVHmdXzPjb1oJ6L4QOiSaI4

cURL

curl -g "https://www.simpleinout.com/api/v4/beacons" -X GET \
	-H "Content-Type: application/json" \
	-H "Authorization: Bearer 7mhcJIS-e5uvhiJwhAf0tVHmdXzPjb1oJ6L4QOiSaI4"

Response

Simulated Response

Response Fields

Name Description
beacons (array) an array of beacons

Status

200

Headers

etag: W/"ceaf512fcdcb83ea2b02dedbb53c2b54"

Body

{
  "beacons": [
    {
      "id": "23",
      "name": "2 - Colbyville",
      "uuid": "9D2DAF96-9719-465E-AED9-4DACA52B711E",
      "comment_on_entry": "In at 2 - Colbyville",
      "comment_on_exit": "Left 2 - Colbyville",
      "entry": true,
      "exit": true,
      "status_on_entry": "in",
      "status_on_exit": "out",
      "created_at": 1792002611,
      "updated_at": 1792002611
    },
    {
      "id": "24",
      "name": "3 - Hyattland",
      "uuid": "B2850A6E-33D0-4060-9178-86BF29471842",
      "comment_on_entry": "In at 3 - Hyattland",
      "comment_on_exit": "Left 3 - Hyattland",
      "entry": true,
      "exit": true,
      "status_on_entry": "in",
      "status_on_exit": "out",
      "created_at": 1792002611,
      "updated_at": 1792002611
    }
  ],
  "meta": {
    "paging": {
      "page": 1,
      "page_size": 25,
      "page_count": 1,
      "count": 2,
      "previous_page": null,
      "next_page": null,
      "first_href": "http://example.org/api/v4/beacons",
      "last_href": "http://example.org/api/v4/beacons",
      "previous_href": null,
      "next_href": null
    },
    "last_updated_at": {
      "announcements": 1790965811,
      "beacons": 1792002611,
      "desktop_presences": 1791916211,
      "favorites": 1786559411,
      "fences": 1789583411,
      "groups": 1787509811,
      "networks": 1788546611,
      "roles": 1792002611,
      "settings": 1792002611
    },
    "emergency": null
  }
}

Update a beacon

Updates an existing beacon. Please note that if the UUID of the beacon is updated, any corresponding hardware must also be updated to broadcast the new UUID. Users must have a role that permits managing the company to update beacons.

Endpoint

PATCH /api/v4/beacons/:id

Parameters

Name Description
beacon[name] (string) the name of the beacon
beacon[uuid] (string) the unique beacon identifier
beacon[comment_on_entry] (string) the comment applied to status updates on entry, defaults to 'In at {name}'
beacon[comment_on_exit] (string) the comment applied to status updates on exit, defaults to 'Left {name}'
beacon[status_on_entry] (string) the status to apply on entry: 'in', 'remote', 'busy', 'break', 'out', 'sick', 'vacation', or 'off', defaults to 'in'
beacon[status_on_exit] (string) the status to apply on exit: 'in', 'remote', 'busy', 'break', 'out', 'sick', 'vacation', or 'off', defaults to 'out'

Request

Route

PATCH /api/v4/beacons/26

Headers

Content-Type: application/json
Authorization: Bearer oRTaJF_F3TGCxpgB_jFKMbPDrlmoN5WIINKiTEfhJ70

Body

{
  "beacon": {
    "name": "My Renamed Office"
  }
}

cURL

curl "https://www.simpleinout.com/api/v4/beacons/26" -d '{"beacon":{"name":"My Renamed Office"}}' -X PATCH \
	-H "Content-Type: application/json" \
	-H "Authorization: Bearer oRTaJF_F3TGCxpgB_jFKMbPDrlmoN5WIINKiTEfhJ70"

Response

Simulated Response

Response Fields

Name Description
beacons (object) the newly updated beacon attributes

Status

200

Headers

etag: W/"3da42fbb3e7dc3334bb8fecfe67a8b59"

Body

{
  "beacons": {
    "id": "26",
    "name": "My Renamed Office",
    "uuid": "00766C46-EB74-4CEA-9F6C-7059BCA7A556",
    "comment_on_entry": "In at 4 - Lake Florencio",
    "comment_on_exit": "Left 4 - Lake Florencio",
    "entry": true,
    "exit": true,
    "status_on_entry": "in",
    "status_on_exit": "out",
    "created_at": 1792002611,
    "updated_at": 1792002611
  },
  "meta": {
    "last_updated_at": {
      "announcements": 1789410611,
      "beacons": 1792002611,
      "desktop_presences": 1783449011,
      "favorites": 1787769011,
      "fences": 1783967411,
      "groups": 1787682611,
      "networks": 1783708211,
      "roles": 1792002611,
      "settings": 1792002611
    },
    "emergency": null
  }
}

Companies

Retrieve the current company

Return the company the authorized user belongs to.

Endpoint

GET /api/v4/companies/my

Parameters

Name Description
expand (string) comma-delimited list of extra information to include in the response, possibilities include: 'billing', 'beacons', 'fences', 'groups', 'favorites', 'networks', 'roles'

Request

Route

GET /api/v4/companies/my

Headers

Content-Type: application/json
Authorization: Bearer wr6jsd0wcJ03HjDu0qes0gRgscozha885XrVmjxQ-9Y

cURL

curl -g "https://www.simpleinout.com/api/v4/companies/my" -X GET \
	-H "Content-Type: application/json" \
	-H "Authorization: Bearer wr6jsd0wcJ03HjDu0qes0gRgscozha885XrVmjxQ-9Y"

Response

Simulated Response

Response Fields

Name Description
companies[name] (string) the authorized user's company name
companies[logo_url] (string) url of an image to be used as a fullscreen logo
companies[default_role_id] (string) the unique identifier for the default role
companies[scheduled_statuses] (boolean) whether Scheduled Statuses feature is enabled
companies[available_statuses] (array) the statuses that are available to the company
companies[created_at] (integer) epoch time the company was created

Status

200

Headers

etag: W/"fa388e6af9577bc13f11372ee9f61f63"

Body

{
  "companies": {
    "id": "1211",
    "announcements_enabled": true,
    "available_statuses": [
      "in",
      "out"
    ],
    "name": "Konopelski Inc",
    "scheduled_statuses": true,
    "default_role_id": "5119",
    "logo_url": null,
    "created_at": 1792002610
  },
  "meta": {
    "last_updated_at": {
      "announcements": 1784313010,
      "beacons": 1787250610,
      "desktop_presences": 1786300210,
      "favorites": 1784745010,
      "fences": 1788028210,
      "groups": 1790015410,
      "networks": 1787596210,
      "roles": 1792002610,
      "settings": 1792002610
    },
    "emergency": null
  }
}

Futures

Delete a future status

Deletes an existing scheduled status. The company must have scheduled statuses turned on. Users must have a role that permits managing their own scheduled statuses to delete one of their scheduled statuses. Users must have a role that permits managing the scheduled statuses of others to delete another user’s scheduled status.

Endpoint

DELETE /api/v4/futures/:id

Request

Route

DELETE /api/v4/futures/118

Headers

Content-Type: application/json
Authorization: Bearer FZF1Y0Qzksv4VgYLJNWEKtsR5PGNZxIK_Iixezo9mOo

cURL

curl "https://www.simpleinout.com/api/v4/futures/118" -d '' -X DELETE \
	-H "Content-Type: application/json" \
	-H "Authorization: Bearer FZF1Y0Qzksv4VgYLJNWEKtsR5PGNZxIK_Iixezo9mOo"

Response

Simulated Response

Status

204

List future statuses

List all the scheduled statuses. The company must have scheduled statuses turned on. Users must have a role that permits viewing the scheduled statuses of others or only the authorized user’s scheduled statuses will be returned.

Endpoint

GET /api/v4/futures

Parameters

Name Description
page_size (integer) number of results to return per page, defaults to 25
page (integer) page number of results
status (string) the status: 'in', 'remote', 'busy', 'break', 'out', 'sick', or 'vacation'
comment (string) the comment, case sensitive, included with the status change
apply_at (string) a date range string for the time this status will be added
user_id (string) the ID of a particular user
sort (string) order of the return with optional '-' to denote descending, possibilities include: 'apply_at', 'status', 'comment'"
sort_locale (string) the locale to use when sorting by comment, defaults to English (US)
expand (string) comma-delimited list of extra information to include in the response, possibilities include: 'user', 'changed_by_user'

Request

Route

GET /api/v4/futures

Headers

Content-Type: application/json
Authorization: Bearer 7tPQVRPMCQWd3yThTbhxHHT3GjTr_595gq5l1TiFwic

cURL

curl -g "https://www.simpleinout.com/api/v4/futures" -X GET \
	-H "Content-Type: application/json" \
	-H "Authorization: Bearer 7tPQVRPMCQWd3yThTbhxHHT3GjTr_595gq5l1TiFwic"

Response

Simulated Response

Response Fields

Name Description
futures (array) an array of matching future statuses

Status

200

Headers

etag: W/"b671950926e69a5f63c2495c68db2568"

Body

{
  "futures": [
    {
      "id": "116",
      "status": "out",
      "comment": "On Vacation, back Monday",
      "completed": false,
      "apply_at": 1794682800,
      "end_at": 1794855600,
      "user_id": "1824",
      "changed_by_user_id": null
    },
    {
      "id": "117",
      "status": "out",
      "comment": "At the conference this week",
      "completed": false,
      "apply_at": 1807725600,
      "end_at": null,
      "user_id": "1824",
      "changed_by_user_id": null
    }
  ],
  "meta": {
    "paging": {
      "page": 1,
      "page_size": 25,
      "page_count": 1,
      "count": 2,
      "previous_page": null,
      "next_page": null,
      "first_href": "http://example.org/api/v4/futures",
      "last_href": "http://example.org/api/v4/futures",
      "previous_href": null,
      "next_href": null
    },
    "last_updated_at": {
      "announcements": 1790274611,
      "beacons": 1786559411,
      "desktop_presences": 1787423411,
      "favorites": 1783794611,
      "fences": 1790533811,
      "groups": 1787423411,
      "networks": 1785263411,
      "roles": 1792002611,
      "settings": 1792002611
    },
    "emergency": null
  }
}

Geofences

Create a fence

Creates a new fence. Once this fence is created, it will appear in the company’s fences within the Simple In/Out apps and website. Users must have a role that permits managing the company to create fences. Companies are limited to 150 Geofences.

Endpoint

POST /api/v4/fences

Parameters

Name Description
fence[name] required (string) the name of the fence
fence[latitude] required (float) the latitude of the center point of the fence
fence[longitude] required (float) the longitude of the center point of the fence
fence[radius] required (integer) the radius of the fence, in meters
fence[comment_on_entry] (string) the comment applied to status updates on entry, defaults to 'In at {name}'
fence[comment_on_exit] (string) the comment applied to status updates on exit, defaults to 'Left {name}'
fence[status_on_entry] (string) the status to apply on entry: 'in', 'remote', 'busy', 'break', 'out', 'sick', 'vacation', or 'off', defaults to 'in'
fence[status_on_exit] (string) the status to apply on exit: 'in', 'remote', 'busy', 'break', 'out', 'sick', 'vacation', or 'off', defaults to 'out'

Request

Route

POST /api/v4/fences

Headers

Content-Type: application/json
Authorization: Bearer 9sFjM28XavycQwzVCPflhL8HEhsKiVAbFOBWEaPLSDU

Body

{
  "fence": {
    "name": "My Office",
    "latitude": 46.877931,
    "longitude": -96.787459,
    "radius": 150
  }
}

cURL

curl "https://www.simpleinout.com/api/v4/fences" -d '{"fence":{"name":"My Office","latitude":46.877931,"longitude":-96.787459,"radius":150}}' -X POST \
	-H "Content-Type: application/json" \
	-H "Authorization: Bearer 9sFjM28XavycQwzVCPflhL8HEhsKiVAbFOBWEaPLSDU"

Response

Simulated Response

Response Fields

Name Description
fences (object) the newly created fence attributes

Status

201

Headers

etag: W/"3d2b47b34c63e2dbc12f7b87c5809f1e"

Body

{
  "fences": {
    "id": "15",
    "name": "My Office",
    "latitude": "46.877931",
    "longitude": "-96.787459",
    "radius": 150,
    "comment_on_entry": "In at My Office",
    "comment_on_exit": "Left My Office",
    "entry": true,
    "exit": true,
    "status_on_entry": "in",
    "status_on_exit": "out",
    "created_at": 1792002612,
    "updated_at": 1792002612
  },
  "meta": {
    "last_updated_at": {
      "announcements": 1791570612,
      "beacons": 1788978612,
      "desktop_presences": 1788373812,
      "favorites": 1784658612,
      "fences": 1792002612,
      "groups": 1790361012,
      "networks": 1784485812,
      "roles": 1792002612,
      "settings": 1792002612
    },
    "emergency": null
  }
}

Delete a fence

Deletes an existing fence. Users must have a role that permits managing the company to delete fences.

Endpoint

DELETE /api/v4/fences/:id

Request

Route

DELETE /api/v4/fences/16

Headers

Content-Type: application/json
Authorization: Bearer y2cBJZjZNqX3qEGAyYOJepSEhSA3yT71Z_NskePxtNg

cURL

curl "https://www.simpleinout.com/api/v4/fences/16" -d '' -X DELETE \
	-H "Content-Type: application/json" \
	-H "Authorization: Bearer y2cBJZjZNqX3qEGAyYOJepSEhSA3yT71Z_NskePxtNg"

Response

Simulated Response

Status

204

List all fences

Return a list of all the fences belonging to the company.

Endpoint

GET /api/v4/fences

Parameters

Name Description
sort (string) order of the return with optional '-' to denote descending, possibilities include: 'name', 'radius
page_size (integer) number of results to return per page, defaults to 25
page (integer) page number of results

Request

Route

GET /api/v4/fences

Headers

Content-Type: application/json
Authorization: Bearer fBdfVX0cX3AAYz2SnTD-o6EoG7AYldeTo3E64c0cNxI

cURL

curl -g "https://www.simpleinout.com/api/v4/fences" -X GET \
	-H "Content-Type: application/json" \
	-H "Authorization: Bearer fBdfVX0cX3AAYz2SnTD-o6EoG7AYldeTo3E64c0cNxI"

Response

Simulated Response

Response Fields

Name Description
fences (array) an array of fences

Status

200

Headers

etag: W/"81181cd208e223fa82f64e5b87450707"

Body

{
  "fences": [
    {
      "id": "17",
      "name": "2 - Lanahaven",
      "latitude": "-8.7303077676",
      "longitude": "-43.1302319245",
      "radius": 15765,
      "comment_on_entry": "In at 2 - Lanahaven",
      "comment_on_exit": "Left 2 - Lanahaven",
      "entry": true,
      "exit": true,
      "status_on_entry": "in",
      "status_on_exit": "out",
      "created_at": 1792002612,
      "updated_at": 1792002612
    },
    {
      "id": "18",
      "name": "3 - Port Nell",
      "latitude": "-12.6830529541",
      "longitude": "-141.3943957649",
      "radius": 2350,
      "comment_on_entry": "In at 3 - Port Nell",
      "comment_on_exit": "Left 3 - Port Nell",
      "entry": true,
      "exit": true,
      "status_on_entry": "in",
      "status_on_exit": "out",
      "created_at": 1792002612,
      "updated_at": 1792002612
    }
  ],
  "meta": {
    "paging": {
      "page": 1,
      "page_size": 25,
      "page_count": 1,
      "count": 2,
      "previous_page": null,
      "next_page": null,
      "first_href": "http://example.org/api/v4/fences",
      "last_href": "http://example.org/api/v4/fences",
      "previous_href": null,
      "next_href": null
    },
    "last_updated_at": {
      "announcements": 1787250612,
      "beacons": 1790447412,
      "desktop_presences": 1783708212,
      "favorites": 1784831412,
      "fences": 1792002612,
      "groups": 1788460212,
      "networks": 1784313012,
      "roles": 1792002612,
      "settings": 1792002612
    },
    "emergency": null
  }
}

Update a fence

Updates an existing fence. Users must have a role that permits managing the company to update fences.

Endpoint

PATCH /api/v4/fences/:id

Parameters

Name Description
fence[name] (string) the name of the fence
fence[latitude] (float) the latitude of the center point of the fence
fence[longitude] (float) the longitude of the center point of the fence
fence[radius] (integer) the radius of the fence, in meters
fence[comment_on_entry] (string) the comment applied to status updates on entry, defaults to 'In at {name}'
fence[comment_on_exit] (string) the comment applied to status updates on exit, defaults to 'Left {name}'
fence[status_on_entry] (string) the status to apply on entry: 'in', 'remote', 'busy', 'break', 'out', 'sick', 'vacation', or 'off', defaults to 'in'
fence[status_on_exit] (string) the status to apply on exit: 'in', 'remote', 'busy', 'break', 'out', 'sick', 'vacation', or 'off', defaults to 'out'

Request

Route

PATCH /api/v4/fences/19

Headers

Content-Type: application/json
Authorization: Bearer EOliXTxYn3eR62PPQD_5svyw90SOqf2zZTQdLyqYO3o

Body

{
  "fence": {
    "name": "My Renamed Geofence"
  }
}

cURL

curl "https://www.simpleinout.com/api/v4/fences/19" -d '{"fence":{"name":"My Renamed Geofence"}}' -X PATCH \
	-H "Content-Type: application/json" \
	-H "Authorization: Bearer EOliXTxYn3eR62PPQD_5svyw90SOqf2zZTQdLyqYO3o"

Response

Simulated Response

Response Fields

Name Description
fences (object) the newly updated fence attributes

Status

200

Headers

etag: W/"4bff52e646c6757d6f8cd68869bced61"

Body

{
  "fences": {
    "id": "19",
    "name": "My Renamed Geofence",
    "latitude": "-32.0133427471",
    "longitude": "-121.7413180192",
    "radius": 7628,
    "comment_on_entry": "In at 4 - Lake Orville",
    "comment_on_exit": "Left 4 - Lake Orville",
    "entry": true,
    "exit": true,
    "status_on_entry": "in",
    "status_on_exit": "out",
    "created_at": 1792002612,
    "updated_at": 1792002612
  },
  "meta": {
    "last_updated_at": {
      "announcements": 1786645812,
      "beacons": 1784053812,
      "desktop_presences": 1790879412,
      "favorites": 1783708212,
      "fences": 1792002612,
      "groups": 1788287412,
      "networks": 1787769012,
      "roles": 1792002612,
      "settings": 1792002612
    },
    "emergency": null
  }
}

Groups

Create a group

Creates a new group. Once this group is created, it will appear in the company’s groups within the Simple In/Out apps and website. Users must have a role that permits managing groups/memberships to create groups. Companies are limited to 100 Groups.

Endpoint

POST /api/v4/groups

Parameters

Name Description
group[name] required (string) the name of the group

Request

Route

POST /api/v4/groups

Headers

Content-Type: application/json
Authorization: Bearer N8tbx714vs1MCtSms2fbW74PESGynwGoo-lZeCZH_FI

Body

{
  "group": {
    "name": "New Department"
  }
}

cURL

curl "https://www.simpleinout.com/api/v4/groups" -d '{"group":{"name":"New Department"}}' -X POST \
	-H "Content-Type: application/json" \
	-H "Authorization: Bearer N8tbx714vs1MCtSms2fbW74PESGynwGoo-lZeCZH_FI"

Response

Simulated Response

Response Fields

Name Description
groups (object) the newly created group attributes

Status

201

Headers

etag: W/"ac237ed0e9c8ea9af160e7c24df0b8ac"

Body

{
  "groups": {
    "id": "123",
    "name": "New Department"
  },
  "meta": {
    "last_updated_at": {
      "announcements": 1789065012,
      "beacons": 1791570612,
      "desktop_presences": 1788978612,
      "favorites": 1790101812,
      "fences": 1785349812,
      "groups": 1792002612,
      "networks": 1790879412,
      "roles": 1792002612,
      "settings": 1792002612
    },
    "emergency": null
  }
}

Delete a group

Deletes an existing group. Users must have a role that permits managing groups/memberships to delete groups.

Endpoint

DELETE /api/v4/groups/:id

Request

Route

DELETE /api/v4/groups/125

Headers

Content-Type: application/json
Authorization: Bearer 3gCgmgfH2lRUhrKsIOfpLAxWR0VR0wEFRZlr4mAXMUw

cURL

curl "https://www.simpleinout.com/api/v4/groups/125" -d '' -X DELETE \
	-H "Content-Type: application/json" \
	-H "Authorization: Bearer 3gCgmgfH2lRUhrKsIOfpLAxWR0VR0wEFRZlr4mAXMUw"

Response

Simulated Response

Status

204

List all groups

Return a list of all the groups belonging to the company.

Endpoint

GET /api/v4/groups

Parameters

Name Description
sort (string) order of the return with optional '-' to denote descending, possibilities include: 'name'
page_size (integer) number of results to return per page, defaults to 25
page (integer) page number of results

Request

Route

GET /api/v4/groups

Headers

Content-Type: application/json
Authorization: Bearer yWVtdB-DPiHVpMbiJDkAWp1N3hXBZm9hjf_mY0kWtYI

cURL

curl -g "https://www.simpleinout.com/api/v4/groups" -X GET \
	-H "Content-Type: application/json" \
	-H "Authorization: Bearer yWVtdB-DPiHVpMbiJDkAWp1N3hXBZm9hjf_mY0kWtYI"

Response

Simulated Response

Response Fields

Name Description
groups (array) an array of groups

Status

200

Headers

etag: W/"48c24027d60f250c4baa0ba2a2c77d6c"

Body

{
  "groups": [
    {
      "id": "126",
      "name": "Bashirian, Legros and Monahan10"
    },
    {
      "id": "127",
      "name": "Cruickshank, Schroeder and Jakubowski11"
    }
  ],
  "meta": {
    "paging": {
      "page": 1,
      "page_size": 25,
      "page_count": 1,
      "count": 2,
      "previous_page": null,
      "next_page": null,
      "first_href": "http://example.org/api/v4/groups",
      "last_href": "http://example.org/api/v4/groups",
      "previous_href": null,
      "next_href": null
    },
    "last_updated_at": {
      "announcements": 1787423412,
      "beacons": 1785522612,
      "desktop_presences": 1788633012,
      "favorites": 1789669812,
      "fences": 1783881012,
      "groups": 1792002612,
      "networks": 1791225012,
      "roles": 1792002612,
      "settings": 1792002612
    },
    "emergency": null
  }
}

Update a group

Updates an existing group. Users must have a role that permits managing groups/memberships to update groups.

Endpoint

PATCH /api/v4/groups/:id

Parameters

Name Description
group[name] (string) the name of the group

Request

Route

PATCH /api/v4/groups/124

Headers

Content-Type: application/json
Authorization: Bearer tjqkTwsyEczyvoEpfpdm-_u768KHzvRpu3YQKNfLGkE

Body

{
  "group": {
    "name": "Renamed Department"
  }
}

cURL

curl "https://www.simpleinout.com/api/v4/groups/124" -d '{"group":{"name":"Renamed Department"}}' -X PATCH \
	-H "Content-Type: application/json" \
	-H "Authorization: Bearer tjqkTwsyEczyvoEpfpdm-_u768KHzvRpu3YQKNfLGkE"

Response

Simulated Response

Response Fields

Name Description
groups (object) the newly updated group attributes

Status

200

Headers

etag: W/"0ed46a433a4218bfa98c64706e43ff7f"

Body

{
  "groups": {
    "id": "124",
    "name": "Renamed Department"
  },
  "meta": {
    "last_updated_at": {
      "announcements": 1785263412,
      "beacons": 1786905012,
      "desktop_presences": 1787769012,
      "favorites": 1789065012,
      "fences": 1790101812,
      "groups": 1792002612,
      "networks": 1783535412,
      "roles": 1792002612,
      "settings": 1792002612
    },
    "emergency": null
  }
}

Networks

Create a network

Creates a new network. Once this network is created, it will appear in the company’s networks within the Simple In/Out apps. Users must have a role that permits managing the company to create networks. Companies are limited to 100 Networks.

Endpoint

POST /api/v4/networks

Parameters

Name Description
network[name] required (string) the name of the network, no longer than 44 characters
network[ssid] required (string) the unique network identifier, no longer than 250 characters
network[comment_on_entry] (string) the comment applied to status updates on entry, defaults to 'In at {name}'
network[comment_on_exit] (string) the comment applied to status updates on exit, defaults to 'Left {name}'
network[status_on_entry] (string) the status to apply on entry: 'in', 'remote', 'busy', 'break', 'out', 'sick', 'vacation', or 'off', defaults to 'in'
network[status_on_exit] (string) the status to apply on exit: 'in', 'remote', 'busy', 'break', 'out', 'sick', 'vacation', or 'off', defaults to 'out'
network[nodes] (array) an array of BSSIDs that are the only network equipment associated with this network (if empty all networks with this SSID are valid)

Request

Route

POST /api/v4/networks

Headers

Content-Type: application/json
Authorization: Bearer xX1VvfIn9T7SJswkAsa3Nb9tTctWlIDglnctKXmm4Y8

Body

{
  "network": {
    "name": "My Office",
    "ssid": "Office WiFi Hotspot",
    "nodes": [
      "00:1A:2B:3C:4D:5E",
      "00:1A:2B:3C:4D:5F"
    ]
  }
}

cURL

curl "https://www.simpleinout.com/api/v4/networks" -d '{"network":{"name":"My Office","ssid":"Office WiFi Hotspot","nodes":["00:1A:2B:3C:4D:5E","00:1A:2B:3C:4D:5F"]}}' -X POST \
	-H "Content-Type: application/json" \
	-H "Authorization: Bearer xX1VvfIn9T7SJswkAsa3Nb9tTctWlIDglnctKXmm4Y8"

Response

Simulated Response

Response Fields

Name Description
networks (object) the newly created network attributes

Status

201

Headers

etag: W/"1c4b7cf713e856238e21ef2d351ded94"

Body

{
  "networks": {
    "id": "16",
    "name": "My Office",
    "ssid": "Office WiFi Hotspot",
    "comment_on_entry": "In at My Office",
    "comment_on_exit": "Left My Office",
    "entry": true,
    "exit": true,
    "status_on_entry": "in",
    "status_on_exit": "out",
    "nodes": [
      "00:1A:2B:3C:4D:5E",
      "00:1A:2B:3C:4D:5F"
    ],
    "created_at": 1792002608,
    "updated_at": 1792002608
  },
  "meta": {
    "last_updated_at": {
      "announcements": 1785177008,
      "beacons": 1787596208,
      "desktop_presences": 1784053808,
      "favorites": 1791225008,
      "fences": 1786645808,
      "groups": 1790879408,
      "networks": 1792002608,
      "roles": 1792002608,
      "settings": 1792002608
    },
    "emergency": null
  }
}

Delete a network

Deletes an existing network. Users must have a role that permits managing the company to delete networks.

Endpoint

DELETE /api/v4/networks/:id

Request

Route

DELETE /api/v4/networks/15

Headers

Content-Type: application/json
Authorization: Bearer SrWMZtEEmCC3YNSBc6pml3jMDkd0xTCm65T4c0myMmA

cURL

curl "https://www.simpleinout.com/api/v4/networks/15" -d '' -X DELETE \
	-H "Content-Type: application/json" \
	-H "Authorization: Bearer SrWMZtEEmCC3YNSBc6pml3jMDkd0xTCm65T4c0myMmA"

Response

Simulated Response

Status

204

List all networks

Return a list of all the networks belonging to the company.

Endpoint

GET /api/v4/networks

Parameters

Name Description
sort (string) order of the return with optional '-' to denote descending, possibilities include: 'name'
page_size (integer) number of results to return per page, defaults to 25
page (integer) page number of results

Request

Route

GET /api/v4/networks

Headers

Content-Type: application/json
Authorization: Bearer SXj0QJj1z5GlABOwHSPd_3V5SDfY9aKHaC63vJJ_zH0

cURL

curl -g "https://www.simpleinout.com/api/v4/networks" -X GET \
	-H "Content-Type: application/json" \
	-H "Authorization: Bearer SXj0QJj1z5GlABOwHSPd_3V5SDfY9aKHaC63vJJ_zH0"

Response

Simulated Response

Response Fields

Name Description
networks (array) an array of networks

Status

200

Headers

etag: W/"aba41658791c76c5b10174caa2886a65"

Body

{
  "networks": [
    {
      "id": "12",
      "name": "1 - East Lorita",
      "ssid": "pdg90s77k6a8dl3xwv2dlwep1zmh6lgg",
      "comment_on_entry": "In at 1 - East Lorita",
      "comment_on_exit": "Left 1 - East Lorita",
      "entry": true,
      "exit": true,
      "status_on_entry": "in",
      "status_on_exit": "out",
      "nodes": [],
      "created_at": 1792002608,
      "updated_at": 1792002608
    },
    {
      "id": "13",
      "name": "2 - Kirlinport",
      "ssid": "4p1q0ybcjsmof174uingmnbwuim427li",
      "comment_on_entry": "In at 2 - Kirlinport",
      "comment_on_exit": "Left 2 - Kirlinport",
      "entry": true,
      "exit": true,
      "status_on_entry": "in",
      "status_on_exit": "out",
      "nodes": [],
      "created_at": 1792002608,
      "updated_at": 1792002608
    }
  ],
  "meta": {
    "paging": {
      "page": 1,
      "page_size": 25,
      "page_count": 1,
      "count": 2,
      "previous_page": null,
      "next_page": null,
      "first_href": "http://example.org/api/v4/networks",
      "last_href": "http://example.org/api/v4/networks",
      "previous_href": null,
      "next_href": null
    },
    "last_updated_at": {
      "announcements": 1784572208,
      "beacons": 1783449008,
      "desktop_presences": 1791743408,
      "favorites": 1786127408,
      "fences": 1791225008,
      "groups": 1787509808,
      "networks": 1792002608,
      "roles": 1792002608,
      "settings": 1792002608
    },
    "emergency": null
  }
}

Update a network

Updates an existing network. Please note that if the SSID of the network is updated, any corresponding hardware must also be updated to broadcast the new SSID. Users must have a role that permits managing the company to update networks.

Endpoint

PATCH /api/v4/networks/:id

Parameters

Name Description
network[name] (string) the name of the network, no longer than 44 characters
network[ssid] (string) the unique network identifier, no longer than 250 characters
network[comment_on_entry] (string) the comment applied to status updates on entry, defaults to 'In at {name}'
network[comment_on_exit] (string) the comment applied to status updates on exit, defaults to 'Left {name}'
network[status_on_entry] (string) the status to apply on entry: 'in', 'remote', 'busy', 'break', 'out', 'sick', 'vacation', or 'off', defaults to 'in'
network[status_on_exit] (string) the status to apply on exit: 'in', 'remote', 'busy', 'break', 'out', 'sick', 'vacation', or 'off', defaults to 'out'
network[nodes] (array) an array of BSSIDs that are the only network equipment associated with this network (if empty all networks with this SSID are valid)

Request

Route

PATCH /api/v4/networks/14

Headers

Content-Type: application/json
Authorization: Bearer 9jiBEApNAooV60jyWPU7hcPsB61V2EImHiKiS6bh1xU

Body

{
  "network": {
    "name": "My Renamed Office",
    "nodes": [
      "00:1A:2B:3C:4D:5E",
      "00:1A:2B:3C:4D:5F"
    ]
  }
}

cURL

curl "https://www.simpleinout.com/api/v4/networks/14" -d '{"network":{"name":"My Renamed Office","nodes":["00:1A:2B:3C:4D:5E","00:1A:2B:3C:4D:5F"]}}' -X PATCH \
	-H "Content-Type: application/json" \
	-H "Authorization: Bearer 9jiBEApNAooV60jyWPU7hcPsB61V2EImHiKiS6bh1xU"

Response

Simulated Response

Response Fields

Name Description
networks (object) the newly updated network attributes

Status

200

Headers

etag: W/"4cd84a2480ceb03e692ec3725dc373b1"

Body

{
  "networks": {
    "id": "14",
    "name": "My Renamed Office",
    "ssid": "1tmj5k8mhsan5886xzt07kvdt4638mdu",
    "comment_on_entry": "In at 3 - South Morriston",
    "comment_on_exit": "Left 3 - South Morriston",
    "entry": true,
    "exit": true,
    "status_on_entry": "in",
    "status_on_exit": "out",
    "nodes": [
      "00:1A:2B:3C:4D:5E",
      "00:1A:2B:3C:4D:5F"
    ],
    "created_at": 1792002608,
    "updated_at": 1792002608
  },
  "meta": {
    "last_updated_at": {
      "announcements": 1785004208,
      "beacons": 1787077808,
      "desktop_presences": 1790620208,
      "favorites": 1791657008,
      "fences": 1783621808,
      "groups": 1784140208,
      "networks": 1792002608,
      "roles": 1792002608,
      "settings": 1792002608
    },
    "emergency": null
  }
}

Ok

Make sure things are Ok

This API is only used to verify you’ve successfully authorized.

Endpoint

GET /api/v4/ok

Parameters

Name Description
meta (string) if any value included, will return meta information instead of a 204 No Content response

Request

Route

GET /api/v4/ok

Headers

Content-Type: application/json
Authorization: Bearer Oyva3_q08H7tE2NxgydYbCIpv0uvf7125BCFu0Y6cQo

cURL

curl -g "https://www.simpleinout.com/api/v4/ok" -X GET \
	-H "Content-Type: application/json" \
	-H "Authorization: Bearer Oyva3_q08H7tE2NxgydYbCIpv0uvf7125BCFu0Y6cQo"

Response

Simulated Response

Status

204

Reports

Retrieve another user's report

Retrieves a day-by-day report for another user in the same company. Users must have a role that permits viewing report history for others.

Endpoint

GET /api/v4/users/:id/reports

Parameters

Name Description
date_range required (string) a date range string for the report period
comment (string) optional comment filter; only count status updates whose comment contains this value (case-insensitive)
rounding (string) report duration rounding: 'none', 'hour', or 'quarter_hour'
statuses (string) comma-delimited statuses to count towards totals, possibilities include: 'in', 'remote', 'busy', 'break', 'out', 'sick', 'vacation'
time_zone (string) an IANA time zone to evaluate day boundaries, e.g. 'America/Chicago'
value_format (string) report value format: 'hours', 'labels', or 'minutes'

Request

Route

GET /api/v4/users/1819/reports?date_range=1791781200..1792040399&comment=Planning&rounding=quarter_hour&statuses=in&time_zone=America%2FChicago&value_format=minutes

Headers

Content-Type: application/json
Authorization: Bearer RPUhS8uw9fZpHe-WQLE4Z-5GaWY_K-bRMBoOOxLht4M

Query Parameters

date_range=1791781200..1792040399
comment=Planning
rounding=quarter_hour
statuses=in
time_zone=America/Chicago
value_format=minutes

cURL

curl -g "https://www.simpleinout.com/api/v4/users/1819/reports?date_range=1791781200..1792040399&comment=Planning&rounding=quarter_hour&statuses=in&time_zone=America%2FChicago&value_format=minutes" -X GET \
	-H "Content-Type: application/json" \
	-H "Authorization: Bearer RPUhS8uw9fZpHe-WQLE4Z-5GaWY_K-bRMBoOOxLht4M"

Response

Simulated Response

Response Fields

Name Description
days (array) one result per day in the requested date range
total (string) total value for the requested date range

Status

200

Headers

etag: W/"ecab19cb021617f3368c49396c04b485"

Body

{
  "days": [
    {
      "year": 2026,
      "month": 10,
      "day": 12,
      "result": "0"
    },
    {
      "year": 2026,
      "month": 10,
      "day": 13,
      "result": "480"
    },
    {
      "year": 2026,
      "month": 10,
      "day": 14,
      "result": "0"
    }
  ],
  "total": "480"
}

Retrieve my report

Retrieves a day-by-day report for the authenticated user over the provided date range.

Endpoint

GET /api/v4/users/my/reports

Parameters

Name Description
date_range required (string) a date range string for the report period
comment (string) optional comment filter; only count status updates whose comment contains this value (case-insensitive)
rounding (string) report duration rounding: 'none', 'hour', or 'quarter_hour'
statuses (string) comma-delimited statuses to count towards totals, possibilities include: 'in', 'remote', 'busy', 'break', 'out', 'sick', 'vacation'
time_zone (string) an IANA time zone to evaluate day boundaries, e.g. 'America/Chicago'
value_format (string) report value format: 'hours', 'labels', or 'minutes'

Request

Route

GET /api/v4/users/my/reports?date_range=1791781200..1792040399&comment=Planning&rounding=quarter_hour&statuses=in&time_zone=America%2FChicago&value_format=minutes

Headers

Content-Type: application/json
Authorization: Bearer 8sLkrUptkIYRiUZ3FkfbxrYjnv30anZB4arzpZJGtAE

Query Parameters

date_range=1791781200..1792040399
comment=Planning
rounding=quarter_hour
statuses=in
time_zone=America/Chicago
value_format=minutes

cURL

curl -g "https://www.simpleinout.com/api/v4/users/my/reports?date_range=1791781200..1792040399&comment=Planning&rounding=quarter_hour&statuses=in&time_zone=America%2FChicago&value_format=minutes" -X GET \
	-H "Content-Type: application/json" \
	-H "Authorization: Bearer 8sLkrUptkIYRiUZ3FkfbxrYjnv30anZB4arzpZJGtAE"

Response

Simulated Response

Response Fields

Name Description
days (array) one result per day in the requested date range
total (string) total value for the requested date range

Status

200

Headers

etag: W/"ecab19cb021617f3368c49396c04b485"

Body

{
  "days": [
    {
      "year": 2026,
      "month": 10,
      "day": 12,
      "result": "0"
    },
    {
      "year": 2026,
      "month": 10,
      "day": 13,
      "result": "480"
    },
    {
      "year": 2026,
      "month": 10,
      "day": 14,
      "result": "0"
    }
  ],
  "total": "480"
}

Roles

Create a role

Creates a new role. Once this role is created, it will be available to assign to users within the Simple In/Out apps and website. Users must have a role that permits managing the company to create roles. Companies are limited to 100 Roles.

Endpoint

POST /api/v4/roles

Parameters

Name Description
role[name] required (string) the name of the role, no longer than 255 characters, must be unique for the company
role[billing] (boolean) these users can change the company's plan, credit card, and invoice email/information.
role[followed_users] (boolean) these users can receive notifications on their devices when another user updates their status.
role[reminders] (boolean) these users can manage notifications sent to other users reminding them to update their status.
role[safeties] (boolean) these users can receive notifications when another user hasn't updated their status.
role[user_board] (boolean) these users can see all other users and their current status.
role[manage_all_announcements] (boolean) these users can manage all announcements.
role[manage_groups_and_memberships] (boolean) these users can manage groups and which users are assigned to each group.
role[manage_others_archives] (boolean) these users can change the past statuses of all others by adding and deleting status updates.
role[manage_others_futures] (boolean) these users can schedule future status updates for all other users.
role[manage_others_status] (boolean) these users can change the current status of all users.
role[manage_own_archives] (boolean) these users can change their own past statuses by adding and deleting status updates.
role[manage_own_futures] (boolean) these users can schedule future status updates for themselves.
role[manage_own_status] (boolean) these users can update their own status from any device or the website
role[manage_status_automatically] (boolean) these users can manage their own current status automatically using Geofences, Beacons, Networks, and Desktop Presence.
role[view_all_announcements] (boolean) these users can view all announcements.
role[view_others_archives] (boolean) these users can view the past status updates made by all other users.
role[view_others_futures] (boolean) these users can view the scheduled status updates for all users.
role[view_others_reports] (boolean) these users can run reports on the status history of all other users.
role[view_user_board_updated_at] (boolean) these users can view the time that status updates were made on the board.
role[member_board] (boolean) these users can see other users within the same groups and their current status.
role[manage_member_announcements] (boolean) these users can manage announcements within the same groups.
role[manage_member_archives] (boolean) these users can change the past statuses of users within the same groups by adding and deleting status updates.
role[manage_member_futures] (boolean) these users can schedule future status updates for users within the same groups.
role[manage_member_status] (boolean) these users can change the current status of users within the same groups.
role[view_member_announcements] (boolean) these users can view announcements for everyone and the groups they belong to.
role[view_member_archives] (boolean) these users can view the past status updates made by users within the same groups.
role[view_member_futures] (boolean) these users can view the scheduled status updates for users within the same groups.
role[view_member_reports] (boolean) these users can run reports on the status history of users within the same groups.

Request

Route

POST /api/v4/roles

Headers

Content-Type: application/json
Authorization: Bearer 1ncpiVi-7rIDwMdpvi7_4ZrG3WjHVes-7j6PHvfptZA

Body

{
  "role": {
    "name": "Billing Role",
    "billing": true,
    "followed_users": false,
    "reminders": false,
    "safeties": false,
    "user_board": false,
    "manage_all_announcements": false,
    "manage_groups_and_memberships": false,
    "manage_others_archives": false,
    "manage_others_futures": false,
    "manage_others_status": false,
    "manage_own_archives": false,
    "manage_own_futures": false,
    "manage_own_status": false,
    "manage_status_automatically": false,
    "view_all_announcements": true,
    "view_others_archives": false,
    "view_others_futures": false,
    "view_others_reports": false,
    "view_user_board_updated_at": false,
    "member_board": false,
    "manage_member_announcements": false,
    "manage_member_archives": false,
    "manage_member_futures": false,
    "manage_member_status": false,
    "view_member_announcements": false,
    "view_member_archives": false,
    "view_member_futures": false,
    "view_member_reports": false
  }
}

cURL

curl "https://www.simpleinout.com/api/v4/roles" -d '{"role":{"name":"Billing Role","billing":true,"followed_users":false,"reminders":false,"safeties":false,"user_board":false,"manage_all_announcements":false,"manage_groups_and_memberships":false,"manage_others_archives":false,"manage_others_futures":false,"manage_others_status":false,"manage_own_archives":false,"manage_own_futures":false,"manage_own_status":false,"manage_status_automatically":false,"view_all_announcements":true,"view_others_archives":false,"view_others_futures":false,"view_others_reports":false,"view_user_board_updated_at":false,"member_board":false,"manage_member_announcements":false,"manage_member_archives":false,"manage_member_futures":false,"manage_member_status":false,"view_member_announcements":false,"view_member_archives":false,"view_member_futures":false,"view_member_reports":false}}' -X POST \
	-H "Content-Type: application/json" \
	-H "Authorization: Bearer 1ncpiVi-7rIDwMdpvi7_4ZrG3WjHVes-7j6PHvfptZA"

Response

Simulated Response

Response Fields

Name Description
roles (object) the newly created role attributes

Status

201

Headers

etag: W/"dce07d9829b50d543fafcc4bcb918af4"

Body

{
  "roles": {
    "id": "5191",
    "name": "Billing Role",
    "billing": true,
    "followed_users": false,
    "reminders": false,
    "safeties": false,
    "user_board": false,
    "manage_all_announcements": false,
    "manage_company_and_users": false,
    "manage_groups_and_memberships": false,
    "manage_member_announcements": false,
    "manage_others_archives": false,
    "manage_others_futures": false,
    "manage_others_status": false,
    "manage_own_archives": false,
    "manage_own_futures": false,
    "manage_own_status": false,
    "manage_status_automatically": false,
    "view_all_announcements": true,
    "view_member_announcements": false,
    "view_others_archives": false,
    "view_others_futures": false,
    "view_others_reports": false,
    "member_board": false,
    "manage_member_archives": false,
    "manage_member_futures": false,
    "manage_member_status": false,
    "view_member_archives": false,
    "view_member_futures": false,
    "view_member_reports": false,
    "view_user_board_updated_at": false,
    "created_at": 1792002611,
    "updated_at": 1792002611
  },
  "meta": {
    "last_updated_at": {
      "announcements": 1783967411,
      "beacons": 1785522611,
      "desktop_presences": 1792002611,
      "favorites": 1783794611,
      "fences": 1787855411,
      "groups": 1784140211,
      "networks": 1790533811,
      "roles": 1792002611,
      "settings": 1792002611
    },
    "emergency": null
  }
}

Delete a role

Deletes an existing role. Users must have a role that permits managing the company to delete roles.

Endpoint

DELETE /api/v4/roles/:id

Request

Route

DELETE /api/v4/roles/5177

Headers

Content-Type: application/json
Authorization: Bearer BObxsXKRxeBFYRJoFVhOsfr7v6mrYbY1sW4NrHRjvgU

cURL

curl "https://www.simpleinout.com/api/v4/roles/5177" -d '' -X DELETE \
	-H "Content-Type: application/json" \
	-H "Authorization: Bearer BObxsXKRxeBFYRJoFVhOsfr7v6mrYbY1sW4NrHRjvgU"

Response

Simulated Response

Status

204

List all roles

Return a list of all the roles belonging to the company.

Endpoint

GET /api/v4/roles

Parameters

Name Description
sort (string) order of the return with optional '-' to denote descending, possibilities include: 'name'
page_size (integer) number of results to return per page, defaults to 25
page (integer) page number of results

Request

Route

GET /api/v4/roles

Headers

Content-Type: application/json
Authorization: Bearer CaLY8--ULFt4Wx2ZDVT9EcfPcrMJ6PpydFv5OzFuWU8

cURL

curl -g "https://www.simpleinout.com/api/v4/roles" -X GET \
	-H "Content-Type: application/json" \
	-H "Authorization: Bearer CaLY8--ULFt4Wx2ZDVT9EcfPcrMJ6PpydFv5OzFuWU8"

Response

Simulated Response

Response Fields

Name Description
roles (array) an array of roles

Status

200

Headers

etag: W/"8e1f59217529ebb4084d3c2973d64fd7"

Body

{
  "roles": [
    {
      "id": "5178",
      "name": "Administrator",
      "billing": true,
      "followed_users": true,
      "reminders": true,
      "safeties": true,
      "user_board": true,
      "manage_all_announcements": true,
      "manage_company_and_users": true,
      "manage_groups_and_memberships": true,
      "manage_member_announcements": false,
      "manage_others_archives": true,
      "manage_others_futures": true,
      "manage_others_status": true,
      "manage_own_archives": true,
      "manage_own_futures": true,
      "manage_own_status": true,
      "manage_status_automatically": true,
      "view_all_announcements": true,
      "view_member_announcements": false,
      "view_others_archives": true,
      "view_others_futures": true,
      "view_others_reports": true,
      "member_board": false,
      "manage_member_archives": false,
      "manage_member_futures": false,
      "manage_member_status": false,
      "view_member_archives": false,
      "view_member_futures": false,
      "view_member_reports": false,
      "view_user_board_updated_at": true,
      "created_at": 1792002611,
      "updated_at": 1792002611
    },
    {
      "id": "5180",
      "name": "Regular User",
      "billing": false,
      "followed_users": false,
      "reminders": false,
      "safeties": false,
      "user_board": true,
      "manage_all_announcements": false,
      "manage_company_and_users": false,
      "manage_groups_and_memberships": false,
      "manage_member_announcements": false,
      "manage_others_archives": false,
      "manage_others_futures": false,
      "manage_others_status": false,
      "manage_own_archives": false,
      "manage_own_futures": true,
      "manage_own_status": true,
      "manage_status_automatically": true,
      "view_all_announcements": true,
      "view_member_announcements": false,
      "view_others_archives": true,
      "view_others_futures": true,
      "view_others_reports": false,
      "member_board": false,
      "manage_member_archives": false,
      "manage_member_futures": false,
      "manage_member_status": false,
      "view_member_archives": false,
      "view_member_futures": false,
      "view_member_reports": false,
      "view_user_board_updated_at": true,
      "created_at": 1792002611,
      "updated_at": 1792002611
    },
    {
      "id": "5179",
      "name": "Manager",
      "billing": false,
      "followed_users": false,
      "reminders": false,
      "safeties": false,
      "user_board": true,
      "manage_all_announcements": true,
      "manage_company_and_users": false,
      "manage_groups_and_memberships": false,
      "manage_member_announcements": false,
      "manage_others_archives": false,
      "manage_others_futures": true,
      "manage_others_status": true,
      "manage_own_archives": false,
      "manage_own_futures": true,
      "manage_own_status": true,
      "manage_status_automatically": true,
      "view_all_announcements": true,
      "view_member_announcements": false,
      "view_others_archives": true,
      "view_others_futures": true,
      "view_others_reports": true,
      "member_board": false,
      "manage_member_archives": false,
      "manage_member_futures": false,
      "manage_member_status": false,
      "view_member_archives": false,
      "view_member_futures": false,
      "view_member_reports": false,
      "view_user_board_updated_at": true,
      "created_at": 1792002611,
      "updated_at": 1792002611
    },
    {
      "id": "5181",
      "name": "Limited User",
      "billing": false,
      "followed_users": false,
      "reminders": false,
      "safeties": false,
      "user_board": true,
      "manage_all_announcements": false,
      "manage_company_and_users": false,
      "manage_groups_and_memberships": false,
      "manage_member_announcements": false,
      "manage_others_archives": false,
      "manage_others_futures": false,
      "manage_others_status": false,
      "manage_own_archives": false,
      "manage_own_futures": false,
      "manage_own_status": false,
      "manage_status_automatically": false,
      "view_all_announcements": true,
      "view_member_announcements": false,
      "view_others_archives": true,
      "view_others_futures": true,
      "view_others_reports": false,
      "member_board": false,
      "manage_member_archives": false,
      "manage_member_futures": false,
      "manage_member_status": false,
      "view_member_archives": false,
      "view_member_futures": false,
      "view_member_reports": false,
      "view_user_board_updated_at": true,
      "created_at": 1792002611,
      "updated_at": 1792002611
    }
  ],
  "meta": {
    "paging": {
      "page": 1,
      "page_size": 25,
      "page_count": 1,
      "count": 4,
      "previous_page": null,
      "next_page": null,
      "first_href": "http://example.org/api/v4/roles",
      "last_href": "http://example.org/api/v4/roles",
      "previous_href": null,
      "next_href": null
    },
    "last_updated_at": {
      "announcements": 1784572211,
      "beacons": 1783794611,
      "desktop_presences": 1787423411,
      "favorites": 1791397811,
      "fences": 1785177011,
      "groups": 1787769011,
      "networks": 1784745011,
      "roles": 1792002611,
      "settings": 1792002611
    },
    "emergency": null
  }
}

Retrieve a role

Retrieve an existing role.

Endpoint

GET /api/v4/roles/:id

Request

Route

GET /api/v4/roles/5186

Headers

Content-Type: application/json
Authorization: Bearer r1N1nbK4elvZrdl9SYdenpcsfNhLsF2VCI-2WcbtNGQ

cURL

curl -g "https://www.simpleinout.com/api/v4/roles/5186" -X GET \
	-H "Content-Type: application/json" \
	-H "Sio-Version: 1.0.0" \
	-H "Authorization: Bearer r1N1nbK4elvZrdl9SYdenpcsfNhLsF2VCI-2WcbtNGQ"

Response

Simulated Response

Response Fields

Name Description
roles (object) the role attributes

Status

200

Headers

etag: W/"dfb9b0e76301e0ec9dfccc186b582f69"
last-modified: Wed, 14 Oct 2026 18:30:11 GMT

Body

{
  "roles": {
    "id": "5186",
    "name": "Collier, McDermott and Howell",
    "billing": false,
    "followed_users": false,
    "reminders": false,
    "safeties": false,
    "user_board": false,
    "manage_all_announcements": false,
    "manage_company_and_users": false,
    "manage_groups_and_memberships": false,
    "manage_member_announcements": false,
    "manage_others_archives": false,
    "manage_others_futures": false,
    "manage_others_status": false,
    "manage_own_archives": false,
    "manage_own_futures": false,
    "manage_own_status": false,
    "manage_status_automatically": false,
    "view_all_announcements": true,
    "view_member_announcements": false,
    "view_others_archives": false,
    "view_others_futures": false,
    "view_others_reports": false,
    "member_board": false,
    "manage_member_archives": false,
    "manage_member_futures": false,
    "manage_member_status": false,
    "view_member_archives": false,
    "view_member_futures": false,
    "view_member_reports": false,
    "view_user_board_updated_at": false,
    "created_at": 1792002611,
    "updated_at": 1792002611
  },
  "meta": {
    "last_updated_at": {
      "announcements": 1790101811,
      "beacons": 1788978611,
      "desktop_presences": 1784917811,
      "favorites": 1788460211,
      "fences": 1790015411,
      "groups": 1789583411,
      "networks": 1784140211,
      "roles": 1792002611,
      "settings": 1792002611
    },
    "emergency": null,
    "update_available": false
  }
}

Update a role

Updates an existing role. Users must have a role that permits managing the company to update roles.

Endpoint

PATCH /api/v4/roles/:id

Parameters

Name Description
role[name] required (string) the name of the role, no longer than 255 characters, must be unique for the company
role[billing] (boolean) these users can change the company's plan, credit card, and invoice email/information.
role[followed_users] (boolean) these users can receive notifications on their devices when another user updates their status.
role[reminders] (boolean) these users can manage notifications sent to other users reminding them to update their status.
role[safeties] (boolean) these users can receive notifications when another user hasn't updated their status.
role[user_board] (boolean) these users can see all other users and their current status.
role[manage_all_announcements] (boolean) these users can manage all announcements.
role[manage_groups_and_memberships] (boolean) these users can manage groups and which users are assigned to each group.
role[manage_others_archives] (boolean) these users can change the past statuses of all others by adding and deleting status updates.
role[manage_others_futures] (boolean) these users can schedule future status updates for all other users.
role[manage_others_status] (boolean) these users can change the current status of all users.
role[manage_own_archives] (boolean) these users can change their own past statuses by adding and deleting status updates.
role[manage_own_futures] (boolean) these users can schedule future status updates for themselves.
role[manage_own_status] (boolean) these users can update their own status from any device or the website
role[manage_status_automatically] (boolean) these users can manage their own current status automatically using Geofences, Beacons, Networks, and Desktop Presence.
role[view_all_announcements] (boolean) these users can view all announcements.
role[view_others_archives] (boolean) these users can view the past status updates made by all other users.
role[view_others_futures] (boolean) these users can view the scheduled status updates for all users.
role[view_others_reports] (boolean) these users can run reports on the status history of all other users.
role[view_user_board_updated_at] (boolean) these users can view the time that status updates were made on the board.
role[member_board] (boolean) these users can see other users within the same groups and their current status.
role[manage_member_announcements] (boolean) these users can manage announcements within the same groups.
role[manage_member_archives] (boolean) these users can change the past statuses of users within the same groups by adding and deleting status updates.
role[manage_member_futures] (boolean) these users can schedule future status updates for users within the same groups.
role[manage_member_status] (boolean) these users can change the current status of users within the same groups.
role[view_member_announcements] (boolean) these users can view announcements for everyone and the groups they belong to.
role[view_member_archives] (boolean) these users can view the past status updates made by users within the same groups.
role[view_member_futures] (boolean) these users can view the scheduled status updates for users within the same groups.
role[view_member_reports] (boolean) these users can run reports on the status history of users within the same groups.

Request

Route

PATCH /api/v4/roles/5196

Headers

Content-Type: application/json
Authorization: Bearer HEeRteRx1Okl8OLXGleUYm9ayDOLDtqZMSoQ9C_1btM

Body

{
  "role": {
    "name": "My Renamed Role",
    "billing": false,
    "view_others_archives": true,
    "view_others_futures": true
  }
}

cURL

curl "https://www.simpleinout.com/api/v4/roles/5196" -d '{"role":{"name":"My Renamed Role","billing":false,"view_others_archives":true,"view_others_futures":true}}' -X PATCH \
	-H "Content-Type: application/json" \
	-H "Authorization: Bearer HEeRteRx1Okl8OLXGleUYm9ayDOLDtqZMSoQ9C_1btM"

Response

Simulated Response

Response Fields

Name Description
roles (object) the newly updated role attributes

Status

200

Headers

etag: W/"aabfe0bd8690ae17755e121f5b74e506"

Body

{
  "roles": {
    "id": "5196",
    "name": "My Renamed Role",
    "billing": false,
    "followed_users": false,
    "reminders": false,
    "safeties": false,
    "user_board": false,
    "manage_all_announcements": false,
    "manage_company_and_users": false,
    "manage_groups_and_memberships": false,
    "manage_member_announcements": false,
    "manage_others_archives": false,
    "manage_others_futures": false,
    "manage_others_status": false,
    "manage_own_archives": false,
    "manage_own_futures": false,
    "manage_own_status": false,
    "manage_status_automatically": false,
    "view_all_announcements": true,
    "view_member_announcements": false,
    "view_others_archives": true,
    "view_others_futures": true,
    "view_others_reports": false,
    "member_board": false,
    "manage_member_archives": false,
    "manage_member_futures": false,
    "manage_member_status": false,
    "view_member_archives": false,
    "view_member_futures": false,
    "view_member_reports": false,
    "view_user_board_updated_at": false,
    "created_at": 1792002611,
    "updated_at": 1792002611
  },
  "meta": {
    "last_updated_at": {
      "announcements": 1789237811,
      "beacons": 1789410611,
      "desktop_presences": 1785177011,
      "favorites": 1783535411,
      "fences": 1788028211,
      "groups": 1789497011,
      "networks": 1785349811,
      "roles": 1792002611,
      "settings": 1792002611
    },
    "emergency": null
  }
}

Statuses

List statuses

List all the statuses within the time period specified by the ‘created_at’ date range. Users must have a role that permits viewing the status history of others or only the authorized user’s statuses will be returned.

Endpoint

GET /api/v4/statuses

Parameters

Name Description
page_size (integer) number of results to return per page, defaults to 25
page (integer) page number of results
created_at required (string) a date range string for the time the status was created
status (string) the status: 'in', 'remote', 'busy', 'break', 'out', 'sick', or 'vacation'
comment (string) the comment, case sensitive, included with the status change
automatic (boolean) only find automatic statuses
user_id (string) the ID of a particular user
sort (string) order of the return with optional '-' to denote descending, possibilities include: 'created_at', 'status', 'comment', 'automatic'
sort_locale (string) the locale to use when sorting by comment, defaults to English (US)
expand (string) comma-delimited list of extra information to include in the response, possibilities include: 'user', 'user.favorites', 'user.latest', 'user.memberships', 'user.memberships.group', 'user.phones', 'user.recents', 'changed_by_user', 'application'

Request

Route

GET /api/v4/statuses?created_at=1791349200..1791608399

Headers

Content-Type: application/json
Authorization: Bearer AB_IV0fXVh9H25E8k026_CC-jAugbgZVakMJLmAzcA8

Query Parameters

created_at=1791349200..1791608399

cURL

curl -g "https://www.simpleinout.com/api/v4/statuses?created_at=1791349200..1791608399" -X GET \
	-H "Content-Type: application/json" \
	-H "Authorization: Bearer AB_IV0fXVh9H25E8k026_CC-jAugbgZVakMJLmAzcA8"

Response

Simulated Response

Response Fields

Name Description
statuses (array) an array of matching statuses

Status

200

Headers

etag: W/"4dff5ce7126d66771aead02b3e7c51de"

Body

{
  "statuses": [
    {
      "status": "in",
      "comment": "At Work",
      "automatic": false,
      "user_id": "1848",
      "changed_by_user_id": null,
      "created_at": 1791356400
    },
    {
      "status": "out",
      "comment": "Left Work",
      "automatic": true,
      "user_id": "1848",
      "changed_by_user_id": null,
      "created_at": 1791370800
    },
    {
      "status": "in",
      "comment": "At Work",
      "automatic": false,
      "user_id": "1848",
      "changed_by_user_id": null,
      "created_at": 1791374400
    },
    {
      "status": "out",
      "comment": "Left Work",
      "automatic": false,
      "user_id": "1848",
      "changed_by_user_id": null,
      "created_at": 1791392400
    },
    {
      "status": "in",
      "comment": "At Work",
      "automatic": true,
      "user_id": "1848",
      "changed_by_user_id": null,
      "created_at": 1791442800
    },
    {
      "status": "out",
      "comment": "Left Work",
      "automatic": true,
      "user_id": "1848",
      "changed_by_user_id": null,
      "created_at": 1791464400
    },
    {
      "status": "out",
      "comment": "On Vacation",
      "automatic": false,
      "user_id": "1848",
      "changed_by_user_id": "1849",
      "created_at": 1791468000
    }
  ],
  "meta": {
    "paging": {
      "page": 1,
      "page_size": 25,
      "page_count": 1,
      "count": 7,
      "previous_page": null,
      "next_page": null,
      "first_href": "http://example.org/api/v4/statuses?created_at=1791349200..1791608399",
      "last_href": "http://example.org/api/v4/statuses?created_at=1791349200..1791608399",
      "previous_href": null,
      "next_href": null
    },
    "last_updated_at": {
      "announcements": 1785781811,
      "beacons": 1786300211,
      "desktop_presences": 1789237811,
      "favorites": 1788719411,
      "fences": 1786473011,
      "groups": 1784658611,
      "networks": 1783449011,
      "roles": 1792002611,
      "settings": 1792002611
    },
    "emergency": null
  }
}

Users

Archive a user

Archives an existing user. Users must have a role that permits managing users.

Endpoint

POST /api/v4/users/:id/archive

Request

Route

POST /api/v4/users/1714/archive

Headers

Content-Type: application/json
Authorization: Bearer 8YxCyE66XG1gRr9qh27UzR9mD46HNi7S0YXb3riaPms

cURL

curl "https://www.simpleinout.com/api/v4/users/1714/archive" -d '' -X POST \
	-H "Content-Type: application/json" \
	-H "Authorization: Bearer 8YxCyE66XG1gRr9qh27UzR9mD46HNi7S0YXb3riaPms"

Response

Simulated Response

Status

204

Create a future status update for a user

Add a scheduled status for a specific user. Users must have a role that permits managing their own scheduled statuses if updating themselves or be permitted to manage the scheduled statuses of others if updating another user. The company must also have scheduled statuses enabled.

Endpoint

POST /api/v4/users/:id/futures

Parameters

Name Description
future[status] required (string) must be 'in', 'remote', 'busy', 'break', 'out', 'sick', or 'vacation'
future[apply_at] required (integer) epoch time to apply status change, must be in the future, have minutes within (00, 15, 30, 45), and seconds of 0
future[comment] (string) up to 50 character description of the status update
future[end_at] (integer) epoch time to end the scheduled status, must be after apply_at, have minutes within (00, 15, 30, 45), and seconds of 0
expand (string) comma-delimited list of extra information to include in the response, possibilities include: 'user', 'changed_by_user'

Request

Route

POST /api/v4/users/1783/futures

Headers

Content-Type: application/json
Authorization: Bearer Wkx46jCt8Q4u7aFY_0s0nCeU_Il45zBEFcDMlic_5Zc

Body

{
  "future": {
    "status": "out",
    "apply_at": 1797274800,
    "comment": "On Vacation",
    "end_at": 1797534000
  }
}

cURL

curl "https://www.simpleinout.com/api/v4/users/1783/futures" -d '{"future":{"status":"out","apply_at":1797274800,"comment":"On Vacation","end_at":1797534000}}' -X POST \
	-H "Content-Type: application/json" \
	-H "Authorization: Bearer Wkx46jCt8Q4u7aFY_0s0nCeU_Il45zBEFcDMlic_5Zc"

Response

Simulated Response

Response Fields

Name Description
futures (object) the newly created future object

Status

201

Headers

etag: W/"bdfcfc6c444d0c5625ad3e5a900bfba6"

Body

{
  "futures": {
    "id": "112",
    "status": "out",
    "comment": "On Vacation",
    "completed": false,
    "apply_at": 1797274800,
    "end_at": 1797534000,
    "user_id": "1783",
    "changed_by_user_id": "1782"
  },
  "meta": {
    "last_updated_at": {
      "announcements": 1790015409,
      "beacons": 1783794609,
      "desktop_presences": 1785695409,
      "favorites": 1784572209,
      "fences": 1784140209,
      "groups": 1783449009,
      "networks": 1790188209,
      "roles": 1792002609,
      "settings": 1792002609
    },
    "emergency": null
  }
}

Create a future status update for the current user

Add a scheduled status for the current user. Users must have a role that permits managing their own scheduled statuses and the company must have scheduled statuses enabled.

Endpoint

POST /api/v4/users/my/futures

Parameters

Name Description
future[status] required (string) must be 'in', 'remote', 'busy', 'break', 'out', 'sick', or 'vacation'
future[apply_at] required (integer) epoch time to apply status change, must be in the future and have minutes within (00, 15, 30, 45), and seconds of 0
future[comment] (string) up to 50 character description of the status update
future[end_at] (integer) epoch time to end the scheduled status, must be after apply_at, have minutes within (00, 15, 30, 45), and seconds of 0
expand (string) comma-delimited list of extra information to include in the response, possibilities include: 'user', 'changed_by_user'

Request

Route

POST /api/v4/users/my/futures

Headers

Content-Type: application/json
Authorization: Bearer V8CATNQwP4L9COaIB-uqlybSC34YiQcmh2rENQKWcO0

Body

{
  "future": {
    "status": "out",
    "apply_at": 1797274800,
    "comment": "On Vacation",
    "end_at": 1797534000
  }
}

cURL

curl "https://www.simpleinout.com/api/v4/users/my/futures" -d '{"future":{"status":"out","apply_at":1797274800,"comment":"On Vacation","end_at":1797534000}}' -X POST \
	-H "Content-Type: application/json" \
	-H "Authorization: Bearer V8CATNQwP4L9COaIB-uqlybSC34YiQcmh2rENQKWcO0"

Response

Simulated Response

Response Fields

Name Description
futures (object) the newly created future object

Status

201

Headers

etag: W/"ce62ed4ec4ac08d9dccba91e008a7ce0"

Body

{
  "futures": {
    "id": "115",
    "status": "out",
    "comment": "On Vacation",
    "completed": false,
    "apply_at": 1797274800,
    "end_at": 1797534000,
    "user_id": "1798",
    "changed_by_user_id": null
  },
  "meta": {
    "last_updated_at": {
      "announcements": 1792002610,
      "beacons": 1791657010,
      "desktop_presences": 1788978610,
      "favorites": 1791916210,
      "fences": 1788805810,
      "groups": 1791743410,
      "networks": 1786645810,
      "roles": 1792002610,
      "settings": 1792002610
    },
    "emergency": null
  }
}

Create a status update for a user

Changes a user’s status. Users must have a role that permits managing their own current status or their own past statuses if updating themselves. Users must be permitted to manage the current status of others or the past status of others if updating another user.

Endpoint

POST /api/v4/users/:id/statuses

Parameters

Name Description
status[status] required (string) must be 'in', 'remote', 'busy', 'break', 'out', 'sick', or 'vacation'
status[comment] (string) up to 50 character description of the status update
status[created_at] (integer) epoch time to apply status change, defaults to the current time (if this parameter is passed the date must be in the past)
expand (string) comma-delimited list of extra information to include in the response, possibilities include: 'user', 'user.favorites', 'user.latest', 'user.memberships', 'user.phones', 'user.recents', 'changed_by_user', 'application'

Request

Route

POST /api/v4/users/1771/statuses

Headers

Content-Type: application/json
Authorization: Bearer M42ABCygUTHYgTJxwMVsJLuTA4yXlw-_dWwW8B8a2cM

Body

{
  "status": {
    "status": "in",
    "comment": "In at HQ"
  }
}

cURL

curl "https://www.simpleinout.com/api/v4/users/1771/statuses" -d '{"status":{"status":"in","comment":"In at HQ"}}' -X POST \
	-H "Content-Type: application/json" \
	-H "Authorization: Bearer M42ABCygUTHYgTJxwMVsJLuTA4yXlw-_dWwW8B8a2cM"

Response

Simulated Response

Response Fields

Name Description
statuses (object) the newly created status object

Status

201

Headers

etag: W/"c84bb4c2f25dd98157779c12b4b119df"

Body

{
  "statuses": {
    "status": "in",
    "comment": "In at HQ",
    "automatic": false,
    "user_id": "1771",
    "changed_by_user_id": "1770",
    "created_at": 1792002609
  },
  "meta": {
    "last_updated_at": {
      "announcements": 1791916209,
      "beacons": 1789756209,
      "desktop_presences": 1784831409,
      "favorites": 1789756209,
      "fences": 1784917809,
      "groups": 1783967409,
      "networks": 1784399409,
      "roles": 1792002609,
      "settings": 1792002609
    },
    "emergency": null
  }
}

Create a status update for the current user

[...]
